{   }

program X;

{$R e:\document\trpo\bpw\lr7\image.res}

uses OWindows, ODialogs, WinTypes, WinProcs, Strings, OPrinter;

const
  Button1=101;
  Button2=103;
  Button3=110;
  TextA=104;
  TextB=105;
  TextC=106;
  StaticA=107;
  StaticB=108;
  StaticC=109;

type
  MyApp=object(TApplication)
    procedure InitMainWindow;virtual;
  end;

  PMyWindow=^TMyWindow;
  TMyWindow=object(TWindow)
    EditA, EditB, EditC: PEdit;
    constructor Init(AParent: PWindowsObject;Atitle: PChar);
    procedure Result(var Msg: TMsg);virtual id_first+Button1;
    procedure Prn(var Msg: TMsg);virtual id_first+Button3;
    procedure Paint(DC:hDC;var Info: TPaintStruct);virtual;
    procedure Exit(var Msg: TMsg);virtual id_first+Button2;
  end;

var Prntr: PPrinter;

procedure MyApp.InitMainWindow;
begin
  MainWindow:=New(PMyWindow, Init(nil, '  '));
end;

constructor TMyWindow.Init(AParent: PWindowsObject;Atitle: PChar);
  var But1, But2, But3: PButton;
      StA, StB, StC: PStatic;
begin
  inherited Init(Aparent, ATitle);
  Attr.X:=0;
  Attr.Y:=0;
  Attr.W:=328;
  Attr.H:=248;
  But1:=New(PButton, Init(@self, Button1, '', 15, 180, 90, 30, False));
  But2:=New(PButton, Init(@self, Button2, '', 115, 180, 90, 30, False));
  But2:=New(PButton, Init(@self, Button3, '', 215, 180, 90, 30, False));
  EditA:=New(PEdit, Init(@self, TextA, '0', 160, 30, 110, 25, 20, False));
  EditB:=New(PEdit, Init(@self, TextB, '0', 160, 60, 110, 25, 20, False));
  EditC:=New(PEdit, Init(@self, TextC, '0', 160, 90, 110, 25, 20, False));
  StA:=New(PStatic, Init(@self, StaticA, ' A:', 50, 30, 100, 20, 10));
  StB:=New(PStatic, Init(@self, StaticB, ' B:', 50, 60, 100, 20, 10));
  StC:=New(PStatic, Init(@self, StaticC, ' C:', 50, 90, 100, 20, 10));
  Prntr:=New(PPrinter, Init);
end;

procedure TMyWindow.Exit(var Msg: TMsg);
begin
  inherited Done;
end;

procedure TMyWindow.Prn(var Msg: TMsg);
  var P: PPrintOut;
begin
  P := New(PWindowPrintOut, Init('Widgets', PMyWindow(@self)));
  Prntr^.Print(@self, P);
  Dispose(P, Done);
end;

procedure TMyWindow.Result(var Msg: TMsg);
var
  StartPos, EndPos, i, K1, K2, K3: Integer;
  A, B, C, Res, X1, X2: Real;
  TheText: array[0..20] of Char;
  P, w: String;
  D: PChar;
begin
  EditA^.GetSelection(StartPos, EndPos);
  if StartPos = EndPos then
  EditA^.GetText(TheText, 20)
  else EditA^.GetSubText(TheText, StartPos, EndPos);
  D:=@TheText[0];
  P:=StrPas(D);
  val(P, A, K1);

  EditB^.GetSelection(StartPos, EndPos);
  if StartPos = EndPos then
  EditB^.GetText(TheText, 20)
  else EditB^.GetSubText(TheText, StartPos, EndPos);
  D:=@TheText[0];
  P:=StrPas(D);
  val(P, B, K2);

  EditC^.GetSelection(StartPos, EndPos);
  if StartPos = EndPos then
  EditC^.GetText(TheText, 20)
  else EditC^.GetSubText(TheText, StartPos, EndPos);
  D:=@TheText[0];
  P:=StrPas(D);
  val(P, C, K3);

  if (K1<>0) or (K2<>0) or (K3<>0) then
    MessageBox(hWindow, '  !', '', mb_OK+mb_ICONSTOP)
  else begin
    Res:=Sqr(B)-4*A*C;
    if Res<0 then
      MessageBox(hWindow, '   ', '', mb_OK+MB_ICONINFORMATION)
    else begin
      if Res=0 then begin
        Res:=b/(2*A);
        Str(Res:3:3, w);
        D:=@w[1];
        MessageBox(hWindow, D, ': X=', mb_OK+MB_ICONINFORMATION)
      end
      else begin
        X1:=(b-Sqrt(Res))/(2*A);
        Str(X1:3:3, w);
        D:=@w[1];
        MessageBox(hWindow, D, ' X1=', mb_OK+mb_ICONINFORMATION);
        X2:=(b+Sqrt(Res))/(2*A);
        Str(X2:3:3, w);
        D:=@w[1];
        MessageBox(hWindow, D, ' X2=', mb_OK+mb_ICONINFORMATION);
      end;
    end;
  end;
end;

procedure TMyWindow.Paint(DC:hDC;var Info: TPaintStruct);
  var
    MemDC:hDC;
    BM:hBitMap;
begin
  BM:=LoadBitMap(hInstance, 'BITMAP_1');
  MemDC:=CreateCompatibleDC(DC);
  SelectObject(MemDC, BM);
  BitBlt(DC, 0, 0, 321, 262, MemDC, 0, 0, SrcCopy);
  DeleteDC(MemDC);
  DeleteObject(BM);
end;

var A: MyApp;

begin
  A.Init('');
  A.Run;
  A.Done;
end.